#include "pwm.h"
#include "sys.h"


#define PWM1_1      0x00	//P:P1.0  N:P1.1
#define PWM1_2      0x01	//P:P2.0  N:P2.1
#define PWM1_3      0x02	//P:P6.0  N:P6.1

#define PWM2_1      0x00	//P:P1.2/P5.4  N:P1.3
#define PWM2_2      0x04	//P:P2.2  N:P2.3
#define PWM2_3      0x08	//P:P6.2  N:P6.3

#define PWM3_1      0x00	//P:P1.4  N:P1.5
#define PWM3_2      0x10	//P:P2.4  N:P2.5
#define PWM3_3      0x20	//P:P6.4  N:P6.5

#define PWM4_1      0x00	//P:P1.6  N:P1.7
#define PWM4_2      0x40	//P:P2.6  N:P2.7
#define PWM4_3      0x80	//P:P6.6  N:P6.7
#define PWM4_4      0xC0	//P:P3.4  N:P3.3

#define ENO1P       0x01
#define ENO1N       0x02
#define ENO2P       0x04
#define ENO2N       0x08
#define ENO3P       0x10
#define ENO3N       0x20
#define ENO4P       0x40
#define ENO4N       0x80


#define	DEFLUT_FZ		1000UL

void pwm_config()
{
	uint16_t	arr_value ;
	uint16_t	ccr_value ;
	
	PWMA_CCER1 = 0x00; //д CCMRx ǰ CCxE رͨ
	PWMA_CCER2 = 0x00;
	PWMA_CCMR1 = 0x60; //ͨģʽ
//    PWMA_CCMR2 = 0x60;
//    PWMA_CCMR3 = 0x60;
//    PWMA_CCMR4 = 0x60;
	PWMA_CCER1 = 0x05; //ͨʹܺͼ
//    PWMA_CCER2 = 0x55;
	PWMA_CCMR1 |= 0x08; //PWMA_CCRxԤתع(ҪCCxE=1ſд)
//    PWMA_CCMR2 |= 0x08;
//    PWMA_CCMR3 |= 0x08;
//    PWMA_CCMR4 |= 0x08;
	arr_value = MAIN_Fosc/DEFLUT_FZ;
	ccr_value = arr_value/2;
	
	PWMA_ARRH = (uint8_t)((arr_value>>8)&0x00ff); //ʱ
	PWMA_ARRL = (uint8_t)((arr_value)&0x00ff);

	PWMA_CCR1H = (uint8_t)((ccr_value>>8)&0x00ff); //ռձʱ
	PWMA_CCR1L = (uint8_t)((ccr_value)&0x00ff);

	PWMA_DTR = 0x0C;   //ʱ

	PWMA_ENO = 0x00;
	PWMA_ENO |= ENO1P; //ʹ
	PWMA_ENO |= ENO1N; //ʹ
//    PWMA_ENO |= ENO2P; //ʹ
//    PWMA_ENO |= ENO2N; //ʹ
//    PWMA_ENO |= ENO3P; //ʹ
//    PWMA_ENO |= ENO3N; //ʹ
//    PWMA_ENO |= ENO4P; //ʹ
//    PWMA_ENO |= ENO4N; //ʹ
	//߼PWMŻԶΪģʽ
	PWMA_PS = 0x00;  //߼ PWM ͨѡλ
	PWMA_PS |= PWM1_3; //ѡ PWM1_3 ͨ
//    PWMA_PS |= PWM2_3; //ѡ PWM2_3 ͨ
//    PWMA_PS |= PWM3_3; //ѡ PWM3_3 ͨ
//    PWMA_PS |= PWM4_3; //ѡ PWM4_3 ͨ
	PWMA_BKR = 0x80; //ʹ
//	PWMA_IER = 0x01; //ʹж
	//PWMA_CR2 = 0x20;
	PWMA_CR1 |= 0x81; //ʹARRԤװأʼʱ
}

void pwm_set_fz(uint32_t f)
{
	uint16_t	arr_value = MAIN_Fosc/f;
	uint16_t	ccr_value = arr_value/2;
	PWMA_CR1 |= 0x02;
	PWMA_ARRH = (uint8_t)((arr_value>>8)&0x00ff); //ʱ
	PWMA_ARRL = (uint8_t)((arr_value)&0x00ff);
	PWMA_CCR1H = (uint8_t)((ccr_value>>8)&0x00ff); //ռձʱ
	PWMA_CCR1L = (uint8_t)((ccr_value)&0x00ff);
	PWMA_CR1 &= ~0x02;

}

