#include "uart.h"
#include "sys.h"
#include "stdio.h"
#include "string.h"


uart_handle edata uart1;
uint8_t edata uart1_tx_buf[UART1_TX_SIZE_MAX] = {1,2,3,4,5,6,7,8,9,10};
uint8_t edata uart1_rx_buf[UART1_RX_SIZE_MAX] = {0};

#define Baudrate1       115200L

void UART1_config(void);    // ѡ, 2: ʹTimer2, ֵ: ʹTimer1.
void UART1_para_init();

uint8_t B_TX1_Busy = 0;
char putchar(char c)
{
    B_TX1_Busy = 1;
    SBUF = c;
    while(B_TX1_Busy);
    return c;
}
	
void uart1_init(void)
{
	UART1_config();
	UART1_para_init();
//	uart_DMA_Config();
//	uart1_recv(UART1_RX_SIZE_MAX);
}

void UART1_config(void)  //ʹTimer1.
{
	TR1 = 0;
	S1BRT = 0;		//S1 BRT Use Timer1;
	T1_CT = 0;		//Timer1 set As Timer
	T1x12 = 1;		//Timer1 set as 1T mode
	TMOD &= ~0x30;  //Timer1_16bitAutoReload;
	TH1 = (uint8_t)((65536UL - (MAIN_Fosc / 4) / Baudrate1) / 256);
	TL1 = (uint8_t)((65536UL - (MAIN_Fosc / 4) / Baudrate1) % 256);
	ET1 = 0;    //ֹж
	TR1  = 1;
	/*************************************************/
	SCON = (SCON & 0x3f) | 0x40;    //UART1ģʽ, 0x00: ͬλ, 0x40: 8λ,ɱ䲨, 0x80: 9λ,̶, 0xc0: 9λ,ɱ䲨
//  PS  = 1;    //ȼж
	ES  = 1;    //ж
	REN = 1;    //
	P_SW1 &= 0x3f;
	P_SW1 |= 0x00;      //UART1 switch to, 0x00: P3.0 P3.1, 0x40: P3.6 P3.7, 0x80: P1.6 P1.7, 0xC0: P4.3 P4.4
}

void UART1_para_init()
{
	uart1.txbuf = uart1_tx_buf;
	uart1.rxbuf = uart1_rx_buf;
	uart1.txbuf_flag = TX_IDLE;
	uart1.rxbuf_flag = RX_IDLE;
	uart1.tx_read_p = 0;
	uart1.tx_write_p = 0;
	uart1.rx_read_p = 0;
	uart1.rx_write_p = 0;
}



uint16_t uart1_recv(uint8_t *buf)
{
	uint16_t num = 0;
	if(uart1.rxbuf_flag != RX_DONE)
	{
		return num;
	}
	else
	{
		while(uart1.rx_write_p  != uart1.rx_read_p)
		{
			buf[num] = uart1.rxbuf[uart1.rx_read_p];
			num++;
			uart1.rx_read_p++;
			uart1.rx_read_p %= UART1_RX_SIZE_MAX;
		}
		uart1.rxbuf_flag = RX_IDLE;
		return num;
	}
}

void uart1_send(uint8_t *buf,uint16_t num)
{
	uint16_t i = 0;
	
	if(num>UART1_TX_SIZE_MAX) return;
	uart1.tx_read_p = uart1.tx_write_p;
	for(i = 0;i < num ;i++)
	{
		uart1.txbuf[uart1.tx_write_p] = buf[i];
		uart1.tx_write_p ++;
		uart1.tx_write_p %= UART1_TX_SIZE_MAX;
	}
	SBUF = uart1.txbuf[uart1.tx_read_p];
}

void UART1_int (void) interrupt 4
{
    if(RI)
    {
        RI = 0;
		uart1.rxbuf[uart1.rx_write_p] = SBUF;
		uart1.rx_write_p ++;
		uart1.rx_write_p %= UART1_RX_SIZE_MAX;
		if(uart1.rx_write_p  == uart1.rx_read_p)
		{
			uart1.rx_read_p++;
			uart1.rx_read_p %= UART1_RX_SIZE_MAX;
		}
		uart1.rxbuf_flag = RX_DONE;
    }
    if(TI)
    {
        TI = 0;
		B_TX1_Busy = 0;
		uart1.tx_read_p ++;
		uart1.tx_read_p %= UART1_TX_SIZE_MAX;
		if(uart1.tx_read_p != uart1.tx_write_p)
		{
			SBUF = uart1.txbuf[uart1.tx_read_p];
			uart1.txbuf_flag = TX_BUSY;
		}
		else
		{
			uart1.txbuf_flag = TX_DONE;
		}
    }
}




