#include "sys.h"


/*************  س    **************/

#define T22M_ADDR   CHIPID11   //22.1184MHz
#define T24M_ADDR   CHIPID12   //24MHz
#define T27M_ADDR   CHIPID13   //27MHz
#define T30M_ADDR   CHIPID14   //30MHz
#define T33M_ADDR   CHIPID15   //33.1776MHz
#define T35M_ADDR   CHIPID16   //35MHz
#define T36M_ADDR   CHIPID17   //36.864MHz
#define T40M_ADDR   CHIPID18   //40MHz
#define T44M_ADDR   CHIPID19   //44.2368MHz
#define T48M_ADDR   CHIPID20   //48MHz

#define VRT6M_ADDR  CHIPID21   //VRTRIM_6M
#define VRT10M_ADDR CHIPID22   //VRTRIM_10M
#define VRT27M_ADDR CHIPID23   //VRTRIM_27M
#define VRT44M_ADDR CHIPID24   //VRTRIM_44M

typedef enum
{
	IRC_500K = 0,		/*0*/
	IRC_1M,
	IRC_2M,
	IRC_3M,
	IRC_5M,
	IRC_6M,
	IRC_8M,
	IRC_10M,
	IRC_11M,
	IRC_12M,
	IRC_15M,
	IRC_18M,
	IRC_20M,
	IRC_22M,
	IRC_24M,
	IRC_27M,
	IRC_30M,
	IRC_33M,
	IRC_35M,
	IRC_36M,
}IRC_IndexType;

typedef enum
{
	IRCBAND_6M = 0,		/*0*/
	IRCBAND_10M,
	IRCBAND_27M,
	IRCBAND_44M,
}IRCBAND_SelType;

uint32_t MAIN_Fosc =	24000000L;	//ʱ

void sys_init(void)
{
	//WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ

    CKCON = 0; //߷XRAMٶ
	EAXFR = 1; //չĴ(XFR)ʹ

    //RSTFLAG |= 0x04;   //ӲλҪP3.2״̬ѡ򣬷ӲλUSBģʽ

//    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
//    P1M1 = 0x00;   P1M0 = 0x40;   //Ϊ׼˫, P1.6λ
//    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
//    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
//    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
//    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
//    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
//	P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫

	//SetMCLK(IRC_24M);
}



//========================================================================
// : void SetMCLK(u8 clk)
// : Ƶ
// : clk: Ƶ
// : none.
// 汾: VER1.0
// : 2022-10-14
// ע: 
//========================================================================
void SetMCLK(uint8_t clk) //Ƶ
{
	if(clk > IRC_36M) return;	//Error
	switch(clk)
	{
	case IRC_500K:
		//ѡ500KHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 48;
		MAIN_Fosc =	500000L;	//ʱ
		break;

	case IRC_1M:
		//ѡ1MHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 24;
		MAIN_Fosc =	1000000L;	//ʱ
		break;

	case IRC_2M:
		//ѡ2MHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 12;
		MAIN_Fosc =	2000000L;	//ʱ
		break;

	case IRC_3M:
		//ѡ3MHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 8;
		MAIN_Fosc =	3000000L;	//ʱ
		break;

	case IRC_5M:
		//ѡ5.5296MHz
		CLKDIV = 0x04;
		IRTRIM = T22M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 4;
		MAIN_Fosc =	5529600L;	//ʱ
		break;

	case IRC_6M:
		//ѡ6MHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 4;
		MAIN_Fosc =	6000000L;	//ʱ
		break;

	case IRC_8M:
		//ѡ8MHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 3;
		MAIN_Fosc =	8000000L;	//ʱ
		break;

	case IRC_10M:
		//ѡ10MHz
		CLKDIV = 0x04;
		IRTRIM = T40M_ADDR;
		//VRTRIM = VRT44M_ADDR;
		IRCBAND = IRCBAND_44M;
		CLKDIV = 4;
		MAIN_Fosc =	10000000L;	//ʱ
		break;

	case IRC_11M:
		//ѡ11.0592MHz
		CLKDIV = 0x04;
		IRTRIM = T22M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 2;
		MAIN_Fosc =	11059200L;	//ʱ
		break;

	case IRC_12M:
		//ѡ12MHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 2;
		MAIN_Fosc =	12000000L;	//ʱ
		break;

	case IRC_15M:
		//ѡ15MHz
		CLKDIV = 0x04;
		IRTRIM = T30M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 2;
		MAIN_Fosc =	15000000L;	//ʱ
		break;

	case IRC_18M:
		//ѡ18.432MHz
		CLKDIV = 0x04;
		IRTRIM = T36M_ADDR;
		//VRTRIM = VRT44M_ADDR;
		IRCBAND = IRCBAND_44M;
		CLKDIV = 2;
		MAIN_Fosc =	18432000L;	//ʱ
		break;

	case IRC_20M:
		//ѡ20MHz
		CLKDIV = 0x04;
		IRTRIM = T40M_ADDR;
		//VRTRIM = VRT44M_ADDR;
		IRCBAND = IRCBAND_44M;
		CLKDIV = 2;
		MAIN_Fosc =	20000000L;	//ʱ
		break;

	case IRC_24M:
		//ѡ24MHz
		CLKDIV = 0x04;
		IRTRIM = T24M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 1;
		MAIN_Fosc =	24000000L;	//ʱ
		break;

	case IRC_27M:
		//ѡ27MHz
		CLKDIV = 0x04;
		IRTRIM = T27M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 1;
		MAIN_Fosc =	27000000L;	//ʱ
		break;

	case IRC_30M:
		//ѡ30MHz
		CLKDIV = 0x04;
		IRTRIM = T30M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 1;
		MAIN_Fosc =	30000000L;	//ʱ
		break;

	case IRC_33M:
		//ѡ33.1176MHz
		CLKDIV = 0x04;
		IRTRIM = T33M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 1;
		MAIN_Fosc =	33117600L;	//ʱ
		break;

	case IRC_35M:
		//ѡ35MHz
		CLKDIV = 0x04;
		IRTRIM = T35M_ADDR;
		//VRTRIM = VRT44M_ADDR;
		IRCBAND = IRCBAND_44M;
		CLKDIV = 1;
		MAIN_Fosc =	35000000L;	//ʱ
		break;

	case IRC_36M:
		//ѡ36.864MHz
		CLKDIV = 0x04;
		IRTRIM = T36M_ADDR;
		//VRTRIM = VRT44M_ADDR;
		IRCBAND = IRCBAND_44M;
		CLKDIV = 1;
		MAIN_Fosc =	36864000L;	//ʱ
		break;

	default:
		//ѡ22.1184MHz
		CLKDIV = 0x04;
		IRTRIM = T22M_ADDR;
		//VRTRIM = VRT27M_ADDR;
		IRCBAND = IRCBAND_27M;
		CLKDIV = 1;
		MAIN_Fosc =	22118400L;	//ʱ
		break;
	}
}

