#ifndef _U_UART_H_
#define _U_UART_H_

#include "STC32G.h"

#define UART1 1

#define UART1_TX_SIZE_MAX		255L
#define UART1_RX_SIZE_MAX		255L



typedef enum{
	TX_IDLE = 0,
	TX_BUSY,
	TX_DONE,
	RX_IDLE,
	RX_DOING,
	RX_DONE,
};

typedef enum{
	Com_1 = 0,
	Com_2,
	Com_3,
	Com_4,
};

typedef struct
{
	uint8_t *txbuf;
	uint8_t *rxbuf;
	uint8_t txbuf_flag;
	uint8_t rxbuf_flag;
	uint16_t tx_read_p;
	uint16_t tx_write_p;
	uint16_t rx_read_p;
	uint16_t rx_write_p;
}uart_handle;

extern uint8_t edata uart1_tx_buf[UART1_TX_SIZE_MAX];
extern uint8_t edata uart1_rx_buf[UART1_RX_SIZE_MAX];

void uart1_init(void);
void uart1_send(uint8_t *buf,uint16_t num);
uint16_t uart1_recv(uint8_t *buf);
#endif